' vecalabeth

CALL SetFrameRate(60)
call IntensitySprite(60)

textSize = {40,5}

D=DrawTo;
M=MoveTo;

luckynumber = 1
framecount = 0
hpincrementer = 0;

outsideX = 0
outsideY = 0

mon = 0
monlocation = 0

currentArray = "NONE"
Dim arrayCache

gameLevel = 1
Dim level[81,5]

seed = 0
mazestart = 0
mazeend = 0
closest = 0

monsters = {"BALRON","MINOTAUR","GREMLIN","MIMIC","CARRION CREEPER","SNAKE","ORC","RAT","THIEF","SKELETON"}  
playerTypes = {"FIGHTER","MAGE"}
monsterHP = {21,19,17,15,13,11,9,7,5,3,1}

' Stores player details. 1 + 2 = X + Y coords. 3 = Direction Facing,4 = food,5 = hp,6 = gold, 7=inside/outside
' (0/1), 8strength, 9dex, 10stam, 11wisdom, 12rapier, 13axe, 14shield, 15bow, 16amulet,17quest, 18questdone, 19 equipped item, 20 player type
call Randomize()

playerDetails = {(Rand() MOD 19) + 2,(Rand() MOD 19) + 2,1,0,99,0,0,25,25,25,25,0,0,0,0,0,0,0,0,1}

controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
while controls[1,3] = 0
	framecount = framecount + 1
	'only allow one move every so often
	
	if framecount >= GetFrameRate()/4 then
		call clearScreen()
		call TextSizeSprite(textSize)
		instructions = {{-118,-30,"BEWARE,"},_
						{-120,-40,"FOOLISH"},_
						{-120,-50,"MORTAL,"},_
						{-110,-60,"YOU"},_
						{-120,-70,"TRESPASS"},_
						{-105,-80,"IN"},_
						{65,-10,"AKALABETH"},_
						{75,-20,"WORLD"},_
						{70,-30,"OF DOOM!!"},_
						{70,-50,"BY LORD"},_
						{70,-60,"BRITISH"},_
						{70,-80,"VECTREX"},_
						{80,-90,"PORT"},_
						{75,-100,"BY PIX"}}
			call TextListSprite(instructions)
		
       call drawLines (buildArray("SPLASH",139,3),250)
       controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
    endif
endwhile
framecount = 0


controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
while controls[1,3] = 0
	framecount = framecount + 1
	'only allow one move every so often
	
	if framecount >= GetFrameRate()/4 then
		call clearScreen()
		call TextSizeSprite(textSize)
		instructions = {{-50,90,"VECALABETH"},_
						{-120,70,"ORIGINAL BY RICHARD GARRIOTT - 1979"},_
						{-70,50,"PORTED BY PIX - 2018"},_
						{-120,30,"WELCOME TO AKALABETH, WORLD OF DOOM!"}}
			call TextListSprite(instructions)
			controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
    endif
endwhile
framecount = 0

while controls[1,3] = 0 or framecount <= GetFrameRate()/2    
	framecount = framecount + 1	
		call clearScreen()
		'call drawGremlin(250)
		instructions = {{-120,90,"SELECT THY LUCKY NUMBER"},_
						{-120,70," " + luckynumber}}
			call TextListSprite(instructions)
	if framecount >= GetFrameRate()/2 then
			if controls[1,2] < 0 and luckynumber > 1 then
			  framecount = 0
			  luckynumber = luckynumber - 1;
			elseif controls[1,2] > 0 and luckynumber < 10 then
			  framecount = 0
			  luckynumber = luckynumber + 1;
			endif	
    endif
	controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
endwhile
framecount = 0

while controls[1,3] = 0 or framecount <= GetFrameRate()/2    
	framecount = framecount + 1	
		call clearScreen()
		call TextSizeSprite(textSize)
		instructions = {{-50,90,"LEVEL OF PLAY (1-10)"},_
						{-50,70," " + gameLevel}}
			call TextListSprite(instructions)
	if framecount >= GetFrameRate()/2 then
			if controls[1,2] < 0 and gameLevel > 1 then
			  framecount = 0
			  gameLevel = gameLevel - 1;
			elseif controls[1,2] > 0 and gameLevel < 10 then
			  framecount = 0
			  gameLevel = gameLevel + 1;
			endif	
    endif
	controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
endwhile
framecount = 0
 
call Stats(1)

framecount = 0
while controls[1,3] = 0  or framecount <= GetFrameRate()/2 
	framecount = framecount + 1	
		call clearScreen()
		call TextSizeSprite(textSize)
		instructions = {{-90,90,"SHALT THOU BE A FIGHTER OR A MAGE?"},_
						{-90,70,playerTypes[playerDetails[20]]}}
		call TextListSprite(instructions)
	if framecount >= GetFrameRate()/2 then
		if controls[1,2] <> 0 then
          if playerDetails[20] = 1 then
		    playerDetails[20] = 2
		  else
		    playerDetails[20] = 1
		  endif		  
		  framecount = 0
		endif
    endif
    controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
endwhile
framecount = 0

' Create the outside terrain
Dim outsideMap[21,21]

FOR x = 1 TO 21
  outsideMap[x, 1] = 1
  outsideMap[1, x]= 1
  outsideMap[x, 21] = 1
  outsideMap[21, x] = 1
NEXT x

FOR x = 2 TO 20
  FOR y = 2 TO 20
    outsideMap[x, y] = INT(POW(((Rand() MOD 101) / 100.0), 5) * 4.5) 
	IF outsideMap[x, y] = 3 AND (Rand() MOD 2) > 0 THEN 
	  outsideMap[x, y] = 0
	ENDIF
  NEXT y
NEXT x

outsideMap[(Rand() MOD 19) + 2, (Rand() MOD 19) + 2] = 5 
outsideMap[playerDetails[1],playerDetails[2]] = 3

'1=balron 2=minotaur 3=gremlin 4=mimic 5=carrioncreeper 6=snake 7=orc 8=rat 9=thief 10=skeleton 11=upladder 12=chest 13=downladder 14=trap(visible) 15 = trap(invisible)
'1-4 = wall type N,E,S,W. 5 = contents of room

Dim level[81,5]

Dim correctPath [81]
Dim wasHere [81]

scaler = {84,55,37,26,15,12,7,5,4}

call Shop()

framecount = 0
call showPositionO()	
while 1 = 1
    controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
	framecount = framecount + 1
	'only allow one move every so often
	
	if framecount >= GetFrameRate()/4 then
	  if playerDetails[5] <=0 then
	    call deaded()
	  endif
	  if controls[1,5] = 1 then	  
	    call Stats(0)
		framecount = 0 	
	  endif
	  if controls[1,6] = 1 then	  
	    call Inv()
		framecount = 0 	
	  endif
      if playerDetails[7] > 0 then 
	      'inside a dungeon
		  if controls[1,3] <> 0 then 
			if level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] = 12 then 'chest
			  call chest()
			elseif level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] = 13 then 'ladderdown
			  playerDetails[7] = playerDetails[7] + 1 
			  call generateLevels()
			  call AddMonsters		  
			  framecount = 0 
			  call showPositionD()
			elseif level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] = 11 then 'ladderup
			  playerDetails[7] = playerDetails[7] - 1 
			  if playerDetails[7] = 0 then			    
				  playerDetails[1]=outsideX;
				  playerDetails[2]=outsideY;
				  playerDetails[5] = playerDetails[5] + hpincrementer
				  hpincrementer = 0;
				  framecount = 0 
			      call showPositionO()
			  else		    
				  call generateLevels()
				  call AddMonsters	  
			      framecount = 0 
			      call showPositionD()
		      endif
			elseif level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] = 14 then 'trap
			  playerDetails[7] = playerDetails[7] + 1 
			  call generateLevels()
			  call AddMonsters
			  call showPositionD()
			endif
		  elseif controls[1,4] <> 0 then
		    call strike()	
            framecount = 0		
            controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 	
            call MoveMonsters				
            framecount = 0
    	    call showPositionD()			
		  endif		  
		  
			  
		  if controls[1,1] < 0 then
			  'turn left
			  playerDetails[3] = playerDetails[3]-1 
			  framecount = 0
			  if playerDetails[3] < 1 then
				playerDetails[3]=4
			  endif
			elseif controls[1,1] > 0 then
			  'turn right
			  playerDetails[3] = playerDetails[3]+1 
			  framecount = 0
			  if playerDetails[3] > 4 then
				playerDetails[3]=1
			  endif				  
		  endif

			if controls[1,2] < 0 then
			  call Move("B")
			elseif controls[1,2] > 0 
			  call Move("F")	
			endif		
			if framecount = 0 and playerDetails[7] > 0 then
			  call showPositionD()		
			endif
	      elseif playerDetails[7] = 0 then 
		    'outside
		    if controls[1,1] < 0 then
		      'move left
			  if outsideMap[playerDetails[1]-1, playerDetails[2]] <> 1 then
			    playerDetails[1] = playerDetails[1]-1 
			    framecount = 0
				playerDetails[4] = playerDetails[4] - 10
				if playerDetails[4] <=0 then
				  playerDetails[4] = 0
				  playerDetails[5] = playerDetails[5] - 10
				endif
			  endif
			elseif controls[1,1] > 0 then
		      'move right
			  if outsideMap[playerDetails[1]+1, playerDetails[2]] <> 1 then
			    playerDetails[1] = playerDetails[1]+1 
			    framecount = 0
				playerDetails[4] = playerDetails[4] - 10
				if playerDetails[4] <=0 then
				  playerDetails[4] = 0
				  playerDetails[5] = playerDetails[5] - 10
				endif
			  endif
			elseif controls[1,2] < 0 then
		      'move down
			  if outsideMap[playerDetails[1], playerDetails[2]-1] <> 1 then
			    playerDetails[2] = playerDetails[2]-1 
			    framecount = 0
				playerDetails[4] = playerDetails[4] - 10
				if playerDetails[4] <=0 then
				  playerDetails[4] = 0
				  playerDetails[5] = playerDetails[5] - 10
				endif
			  endif
			elseif controls[1,2] > 0 then
		      'move up
			  if outsideMap[playerDetails[1], playerDetails[2]+1] <> 1 then
			    playerDetails[2] = playerDetails[2]+1 
			    framecount = 0
				playerDetails[4] = playerDetails[4] - 10
				if playerDetails[4] <=0 then
				  playerDetails[4] = 0
				  playerDetails[5] = playerDetails[5] - 10
				endif
			  endif
			elseif controls[1,3] <> 0 then 
			  'press fire
			  if outsideMap[playerDetails[1], playerDetails[2]] = 4 then 'dungeon 
			    outsideX = playerDetails[1] 
			    outsideY = playerDetails[2] 
			    playerDetails[1] = 1
				playerDetails[2] = 1
				playerDetails[3] = 3
			    playerDetails[7] = 1 
				call generateLevels()
				call AddMonsters
				call showPositionD()
				framecount = 0 
			  elseif outsideMap[playerDetails[1], playerDetails[2]] = 3 then 
				framecount = 0 
			    call shop()		
				framecount = 0 	   
			  elseif outsideMap[playerDetails[1], playerDetails[2]] = 5 then 
				framecount = 0 
				print "entering castle"
			    call LB()
				framecount = 0 
		      endif
			endif
			if framecount = 0 and playerDetails[7] = 0 then
			  call showPositionO()		
			endif
		  endif
    endif
endwhile

sub ShowPositionD()
call clearScreen()
drawnMonster = false
left = playerDetails[3] - 1
right = playerDetails[3] + 1
back  = playerDetails[3] + 2
scale = 250
if left = 0 then
 left = 4
endif
if left = 5 then 
  left = 1 
endif
if back = 5 then
 back = 1
endif
if back = 6 then 
  back = 2 
endif
if right = 0 then 
  right = 4
endif
if right = 5 then 
  right = 1 
endif

x=playerDetails[1]
y=playerDetails[2]
runcount = 1

mon = 0
monlocation = 0
monsterdrawrun = 0
repeat
    Dim WallLines
	
    if runcount <> 1 then
	  if playerDetails[3] = 1 then
		  y = y -1
		elseif playerDetails[3] = 2 then
		  x = x + 1
		elseif playerDetails[3] = 3 then
		  y = y + 1
		elseif playerDetails[3] = 4 then
		  x = x -1
      endif
	endif

    if monsterdrawrun = 0 then
		if level[x + ((y-1) *9),left] = 1 or level[x + ((y-1) *9),left] = 2 or level[x + ((y-1) *9),left] = 3  then
		  WallLines = {{MoveTo,-60,60},{DrawTo,-40,40},{MoveTo,-40,-40},{DrawTo,-60,-60}}
		else   
		  WallLines = {{MoveTo,-60,40},{DrawTo,-40,40},{DrawTo,-40,-40},{DrawTo,-60,-40}}
		  if level[x + ((y-1) *9),back] = 1 or level[x + ((y-1) *9),back] = 2 or level[x + ((y-1) *9),back] = 3	  
			WallLines = AppendArrays(WallLines,{{MoveTo,-60,-40},{DrawTo,-60,40}})
		  else	  	    
			WallLines = AppendArrays(WallLines,{{MoveTo,-60,-60},{DrawTo,-60,60}})
		  endif
		  if runcount > 1 and (level[x + ((y-1) *9),back] = 2 or level[x + ((y-1) *9),back] = 3) then	
			WallLines = AppendArrays(WallLines,{{MoveTo,-60,-60},{DrawTo,-60,60}})
		  endif	
		endif
		

		if level[x + ((y-1) *9),left] = 2 then
		  WallLines = AppendArrays(WallLines,{{MoveTo,-55,-55},{DrawTo,-55,35},{DrawTo,-45,30},{DrawTo,-45,-45}})
		endif	
		
		if level[x + ((y-1) *9),playerDetails[3]] = 1 or level[x + ((y-1) *9),playerDetails[3]] = 2 or level[x + ((y-1) *9),playerDetails[3]] = 3 then
		  WallLines = AppendArrays(WallLines,{{MoveTo,-40,40},{DrawTo,-40,-40},{DrawTo,40,-40},{DrawTo,40,40},{DrawTo,-40,40}})
		endif
		
		if level[x + ((y-1) *9),playerDetails[3]] = 2 then
		  WallLines = AppendArrays(WallLines,{{MoveTo,-20,-40},{DrawTo,-20,20},{DrawTo,20,20},{DrawTo,20,-40}})
		endif
		
		if level[x + ((y-1) *9),right] = 1 or level[x + ((y-1) *9),right] = 2 or level[x + ((y-1) *9),right] = 3 then
		  WallLines = AppendArrays(WallLines,{{MoveTo,60,60},{DrawTo,40,40},{MoveTo,40,-40},{DrawTo,60,-60}})
		else
		  WallLines = AppendArrays(WallLines,{{MoveTo,60,40},{DrawTo,40,40},{DrawTo,40,-40},{DrawTo,60,-40}})
		  if level[x + ((y-1) *9),back] = 1 or level[x + ((y-1) *9),back] = 2 or level[x + ((y-1) *9),back] = 3	  
			WallLines = AppendArrays(WallLines,{{MoveTo,60,-40},{DrawTo,60,40}})
		  else	  	    
			WallLines = AppendArrays(WallLines,{{MoveTo,60,-60},{DrawTo,60,60}})
		  endif	  
		  if runcount > 1 and (level[x + ((y-1) *9),back] = 2 or level[x + ((y-1) *9),back] = 3	) then
			WallLines = AppendArrays(WallLines,{{MoveTo,60,-60},{DrawTo,60,60}})
		  endif
		endif
	
		if level[x + ((y-1) *9),right] = 2  then
		  WallLines = AppendArrays(WallLines,{{MoveTo,55,-55},{DrawTo,55,35},{DrawTo,45,30},{DrawTo,45,-45}})
		endif		
		call returnToOriginSprite()
		'call MoveSprite(1,1)
		'call MoveSprite(-1,-1)
		call ScaleSprite(scale)
		sprite = LinesSprite(WallLines) 	
	endif
	
		if level[x + ((y-1) *9),5] = 1  and drawnMonster = false
		  call DrawBalron(scale)	  
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9)
		  drawnMonster = true
		elseif level[x + ((y-1) *9),5] = 2 and drawnMonster = false
		  call DrawMinotaur(scale) 	   
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9)
		  drawnMonster = true
		elseif level[x + ((y-1) *9),5] = 3 and drawnMonster = false
		  call DrawGremlin(scale)  
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9)	  
		  drawnMonster = true
		elseif level[x + ((y-1) *9),5] = 4
		  call DrawChest(scale) 
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9)
		elseif level[x + ((y-1) *9),5] = 5 and drawnMonster = false
		  call DrawCarrionCreeper(scale)  
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9) 
		elseif level[x + ((y-1) *9),5] = 6 and drawnMonster = false
		  call DrawSnake(scale)  	  	  
		  drawnMonster = true 
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9)
		elseif level[x + ((y-1) *9),5] = 7 and drawnMonster = false
		  call DrawOrc(scale)  	  	  
		  drawnMonster = true    
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9)
		elseif level[x + ((y-1) *9),5] = 8 and drawnMonster = false
		  call DrawRat(scale)  	  	  
		  drawnMonster = true     
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9)
		elseif level[x + ((y-1) *9),5] = 9 and drawnMonster = false
		  call DrawThief(scale)  	  	  
		  drawnMonster = true     
		  mon = level[x + ((y-1) *9),5]
		  print "setting mon to " + mon
		  monlocation = x + ((y-1) *9)
		elseif level[x + ((y-1) *9),5] = 10 and drawnMonster = false
		  call DrawSkeleton(scale)  	  	  
		  drawnMonster = true      
		  mon = level[x + ((y-1) *9),5]
		  monlocation = x + ((y-1) *9)
		elseif level[x + ((y-1) *9),5] = 11 and monsterdrawrun = 0
		  call DrawUpLadder(scale)
		elseif level[x + ((y-1) *9),5] = 12 and monsterdrawrun = 0
		  call DrawChest(scale)   
		elseif level[x + ((y-1) *9),5] = 13 and monsterdrawrun = 0
		  call DrawDownLadder(scale)   
		elseif level[x + ((y-1) *9),5] = 14 and monsterdrawrun = 0
		  call DrawTrap(scale)    	  
		endif
	
	scale = scale - scaler[runcount]
	
	
	if monsterdrawrun = 1 then
	  monsterdrawrun = 2
	elseif (level[x + ((y-1) *9 ),playerDetails[3]] = 2 or level[x + ((y-1) *9 ),playerDetails[3]] = 3) and runcount = 1 then
	  monsterdrawrun = 2
	elseif (level[x + ((y-1) *9 ),playerDetails[3]] = 2 or level[x + ((y-1) *9 ),playerDetails[3]] = 3) and runcount > 1 then
	  monsterdrawrun = 2
	endif
	
	print "wall ahead=" + level[x + ((y-1) *9),playerDetails[3]]
	print "monsterdrawrun=" +monsterdrawrun
	
    runcount = runcount + 1
until level[x + ((y-1) *9 ),playerDetails[3]] = 1 or monsterdrawrun = 2
  

call returnToOriginSprite()
position     = {{-120,-110,"FOOD=" + playerDetails[4]/10},_
                {-120,-120,"HP=" + playerDetails[5]}}
call TextListSprite(position)
endsub

sub showPositionO()
'draw the outside map which is a 3x3 grid around the player position
call returnToOriginSprite()
call clearScreen()
scale = 140
for x=playerDetails[1]-1 to playerDetails[1]+1 
  for y=playerDetails[2]-1 to playerDetails[2]+1
    if outsideMap[x,y] = 1 then ' draw mountain
	  call DrawMountain(x,y,scale)
	elseif outsideMap[x,y] = 2 then 'draw village
	  call DrawVillage(x,y,scale)
	elseif outsideMap[x,y] = 3 then 'draw town
      call DrawTown(x,y,scale)
    elseif outsideMap[x,y] = 4 then 'draw dungeon
	  call DrawDungeon(x,y,scale)
	elseif outsideMap[x,y] = 5 then 'draw castle
	  call DrawCastle(x,y,scale)
	endif
  next y
next x
call drawPlayer(scale)

call returnToOriginSprite()

		call TextSizeSprite(textSize)
position     = {{-120,-110,"FOOD=" + playerDetails[4]/10},_
                {-120,-120,"HP=" + playerDetails[5]}}
call TextListSprite(position)
endsub



sub drawLineSprite(Lines,scale)
  call returnToOriginSprite()
  'call MoveSprite(1,1) 
  'call MoveSprite(-1,-1)
  call ScaleSprite(scale)
  sprite = LinesSprite(Lines)
endsub

sub drawDotsSprite(modeDots,scale)
  call returnToOriginSprite()
  'call MoveSprite(1,1) 
  'call MoveSprite(-1,-1)
  call ScaleSprite(scale)
  sprite = DotsSprite(modeDots)
endsub

sub drawLines(array, scale)
   z = -50 
   scale = scale * 0.9 	
   Dim line 
   for i = 1 to UBound(array,1)
	if array[i,1] = M then
       if i > 1 then
	     call drawLineSprite(line, scale)
	   endif
	   line = {{MoveTo,array[i,2],array[i,3]+z}}
	else
	  line = AppendArrays(line,{{DrawTo,array[i,2],array[i,3]+z}})
    endif	
	
   next i
   call drawLineSprite(line, scale)
endsub

sub drawOutsideLines(x, y, array, scale)
   blocksize = 50
   call returnToOriginSprite()
   'call MoveSprite(1,1) 
   'call MoveSprite(-1,-1)    
   call ScaleSprite(scale)
   call MoveSprite((x-playerDetails[1])*blocksize,(y-playerDetails[2])*blocksize)  
   sprite = LinesSprite(array)
endsub


sub drawSkeleton(scale)	
    'myDots = {{5,22},{-5,22}}				
	call drawLines ({{M,5,72},{D,5,72},{M,-5,72},{D,-5,72}},scale)
	call drawLines (buildArray("SKELETON",41,3),scale)
	'call drawDotsSprite(myDots,scale) 	
	
	'z = -50 
	'scale = scale * 0.9 	
	
endsub

sub drawPlayer(scale)
	call drawOutsideLines (playerDetails[1], playerDetails[2], {{M,2,0},{D,-2,0},{M,0,2},{D,0,-2}},scale)
endsub

sub drawVillage(x, y, scale)
	call drawOutsideLines (x, y, {{M,5,5},{D,-5,5},{D,-5,-5},{D,5,-5},{D,5,5}},scale)
endsub

sub drawDungeon(x, y, scale)
	call drawOutsideLines (x, y, {{M,5,-5},{D,-5,5},{M,-5,-5},{D,5,5}},scale)
endsub

sub drawTrap(scale)
	call drawLines ({{M,30,5},{D,-30,5},{D,-40,-5},{D,40,-5},{D,30,5}},scale)
endsub

sub drawUpLadder(scale)
	call drawLines (buildArray("UPLADDER",19,3),scale)
endsub

sub drawDownLadder(scale)
	call drawLines (buildArray("DOWNLAD",19,3),scale)
endsub

sub drawMountain(x, y, scale)
	call drawOutsideLines (x, y, buildArray("MOUNTAIN",21,3),scale)
endsub

function buildArray (fName, x, y)
  if strComp(currentArray,fName) = 0
    print "from cache"
    return arrayCache
  endif
  Dim array[x,y]
  file = FOpen(fName,"r")
  FOR a = 1 TO x
	  FOR b = 1 TO y
	    s = FGets(file)
	    array[a,b] = convArrayVal(s)
	  NEXT b
  NEXT a
  call FClose(file)
  currentArray = fName
  arrayCache = array
  return array 
endfunction
	   
sub drawCastle(x, y, scale)
	call drawOutsideLines (x, y,{{M,25,25},{D,-25,25},{D,-25,-25},{D,25,-25},{D,25,25},{M,15,15},_
           {D,15,-15},{D,-15,-15},{D,-15,15},{D,15,15},{D,-15,-15},{M,15,-15},{D,-15,15}},scale)
endsub

sub drawTown(x, y, scale)
	call drawOutsideLines (x, y,{{M,15,15},{D,5,15},{D,5,-15},{D,15,-15},{D,15,-5},{D,-15,-5},_
           {D,-15,-15},{D,-5,-15},{D,-5,15},{D,-15,15},{D,-15,5},{D,15,5},{D,15,15}},scale)
endsub

sub drawThief(scale)
	call drawLines (buildArray("THIEF",21,3),scale)
endsub

sub drawRat(scale)
    call drawLines (buildArray("RAT",21,3),scale)
endsub

function convArrayVal(val)
  if StrComp(Mid(val,1,1),"M") = 0 then
    return MoveTo
  elseif StrComp(Mid(val,1,1),"D") = 0 then
    return DrawTo
  else
    return stringToInt(val)
  endif
endfunction

sub drawOrc(scale)		
  call drawLines (buildArray("ORC",47,3),scale)
endsub

sub drawSnake(scale)
  call drawLines (buildArray("SNAKE",39,3),scale)
endsub

sub drawCarrionCreeper(scale)
  call drawLines (buildArray("CARRION",34,3),scale)
endsub

sub drawChest(scale)
	call drawLines ({{M,-13,0},{D,-13,10},{D,7,10},{D,7,0},{D,-13,0},_
	{M,-13,10},{D,-8,15},{D,12,15},{D,12,5},{D,7,0},_
	{M,7,10},{D,12,15}},scale)	
endsub

sub drawGremlin(scale)
	call drawLines ({{M,5.5,10},{D,-4.5,10},{D,0,15},{D,10,20},{D,5.5,15},{D,5.5,10},_
	{M,5.5,10},{D,7.5,6},{D,5.5,3},{D,-4.5,3},{D,-6.5,6},{D,-4.5,10},_
	{M,2.5,3},{D,5.5,0},{D,8,0},{M,-1.5,3},{D,-4.5,0},{D,-8,0},{M,3.5,5},{D,-2.5,5}},scale)	
	z = -50 
	'scale = scale * 0.9  
	'Dots = {{3.5,8+z},{-2.5,8+z}}
	'call drawDotsSprite(Dots,scale)
	
	call drawLines ({{M,3.5,8},{D,3.5,8},{M,-2.5,8},{D,-2.5,8}},scale)
endsub

sub drawBalron(scale)  
  call drawLines (buildArray("BALRON",86,3),scale)
endsub

sub drawMinotaur(scale)
  call drawLines (buildArray("MINOTAUR",122,3),scale)
endsub

sub Shop()
  selectionList = {"QUIT","FOOD","RAPIER","AXE","SHIELD","BOW","AMULET","NOT ENOUGH GOLD","BOUGHT"}
  selection = 1
  oldselection=1
  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
  exitLoop = 0
  firstTime = 1
  while exitLoop = 0 	
	framecount = framecount + 1
	'only allow one move every so often
	
	if framecount >= GetFrameRate()/4 then

		
		if controls[1,2] < 0 and selection > 1 and selection <8 then
		  selection = selection - 1;  
          framecount = 0;		  
		elseif controls[1,2] > 0 and selection < 7 then
		  selection = selection + 1;   
          framecount = 0;		  	  
		endif
		'strip out some of the shopping text since the Vectrex can't cope!
		instructions = {{-120,90, "GOLD     " + playerDetails[6]},_
		                {-120,50, "PRICE ITEM     OWNED"},_
						{-120,30, "1     FOOD(10)  " + playerDetails[4]/10},_
						{-120,10, "8     RAPIER    " + playerDetails[12]},_
						{-120,-10,"5     AXE       " + playerDetails[13]},_
						{-120,-30,"6     SHIELD    " + playerDetails[14]},_
						{-120,-50,"3     BOW       " + playerDetails[15]},_
						{-120,-70,"15    AMULET    " + playerDetails[16]},_
						{-120,-90,"CMD?" + selectionList[selection]}}	
		
		if controls[1,3] = 1 then
		  if selection = 1 and firstTime = 0 then	
			exitLoop = 1
		  elseif selection = 2 then
			if playerDetails[6] >= 1 then
			  playerDetails[6] = playerDetails[6] - 1
			  playerDetails[4] = playerDetails[4] + 100
			  oldselection=selection
			  selection=9
			else
			  oldselection=selection
			  selection=8
			endif		
		  elseif selection = 3 then
		    if playerDetails[20] = 2 then
			  call MagesCant()
			  framecount = 0
			else
				if playerDetails[6] >= 8 then
				  playerDetails[6] = playerDetails[6] - 8
				  playerDetails[12] = playerDetails[12] + 1
				  oldselection=selection
				  selection=9
				else
				  oldselection=selection
				  selection=8
				endif	
            endif				
		  elseif selection = 4 then
			if playerDetails[6] >= 5 then
			  playerDetails[6] = playerDetails[6] - 5
			  playerDetails[13] = playerDetails[13] + 1
			  oldselection=selection
			  selection=9
			else
			  oldselection=selection
			  selection=8
			endif	
		  elseif selection = 5 then
			if playerDetails[6] >= 6 then
			  playerDetails[6] = playerDetails[6] - 6
			  playerDetails[14] = playerDetails[14] + 1
			  oldselection=selection
			  selection=9
			else
			  oldselection=selection
			  selection=8
			endif	
		  elseif selection = 6 then		    
		    if playerDetails[20] = 2 then
			  call MagesCant()
		      framecount = 0
			else
				if playerDetails[6] >= 3 then
				  playerDetails[6] = playerDetails[6] - 3
				  playerDetails[15] = playerDetails[15] + 1
				  oldselection=selection
				  selection=9
				else
				  oldselection=selection
				  selection=8
				endif 
            endif				
		  elseif selection = 7 then
			if playerDetails[6] >= 15 then
			  playerDetails[6] = playerDetails[6] - 15
			  playerDetails[16] = playerDetails[16] + 1
			  oldselection=selection
			  selection=9
			else
			  oldselection=selection
			  selection=8
			endif		
		  elseif selection = 8 or selection = 9 then
			selection = oldselection
		  endif	  
          firstTime = 0
		  framecount = 0
		endif
		
	    call ClearScreen()		
		call TextSizeSprite(textSize)
	    call TextListSprite(instructions)
      'framecount = 0
    endif
    controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
  endwhile
endsub


sub Inv()
  selectionList = {"QUIT","EQUIP RAPIER","EQUIP AXE","EQUIP SHIELD","EQUIP BOW","EQUIP AMULET","STATS","NOT OWNED!","EQUIPPED"}
  selection = 1
  oldselection=1
  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
  exitLoop = 0
  while exitLoop = 0 	
	framecount = framecount + 1
	'only allow one move every so often
	
	if framecount >= GetFrameRate()/4 then
		
		if controls[1,2] < 0 and selection > 1 and selection <8 then
		  selection = selection - 1;     
          framecount = 0;		      	
		elseif controls[1,2] > 0 and selection < 6 then
		  selection = selection + 1;   
          framecount = 0;		  	  
		endif
		
	   instructions = {{-120,90,"FOOD....." + playerDetails[4]/10},_
				{-120,70,"RAPIER..." + playerDetails[12]},_	
				{-120,50,"AXE......" + playerDetails[13]},_
				{-120,30,"SHIELD..." + playerDetails[14]},_
				{-120,10,"BOW......" + playerDetails[15]},_
				{-120,-10,"AMULET..." + playerDetails[16]},_
				{-120,-90,"CMD?" + selectionList[selection]}}
		
		if controls[1,3] = 1 then
		  if selection = 1 then	
			exitLoop = 1
		  elseif playerDetails[20] = 2 and (selection = 2 or selection = 5) then		  
			call MagesCant()
			framecount=0
		  elseif selection >= 2 and selection <=6 then
			if playerDetails[selection + 10] > 0 then
			  playerDetails[19] = selection + 10
			  oldselection=selection
			  selection=9
			else
			  oldselection=selection
			  selection=8
			endif		
		  elseif selection = 7 then
		    call Stats(0)		
			framecount = 0
		  elseif selection = 8 or selection = 9 then
			selection = oldselection
		  endif	  
          framecount = 0;		  		  
		endif
		
	    call ClearScreen()		
		call TextSizeSprite(textSize)
	    call TextListSprite(instructions)
    endif
    controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
  endwhile
endsub

sub rollStats()
	playerDetails[5] =  round(Sqrt((Rand() MOD 1000)/1000.0) * 21 + 4)
	playerDetails[8] =  round(Sqrt((Rand() MOD 1000)/1000.0) * 21 + 4)
	playerDetails[9] =  round(Sqrt((Rand() MOD 1000)/1000.0) * 21 + 4)
	playerDetails[10] =  round(Sqrt((Rand() MOD 1000)/1000.0) * 21 + 4)
	playerDetails[11] =  round(Sqrt((Rand() MOD 1000)/1000.0) * 21 + 4)
	playerDetails[6] =  round(Sqrt((Rand() MOD 1000)/1000.0) * 21 + 4)
endsub

sub Stats(startup)
  if startup = 1 then
    call rollStats()
  endif
  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
  framecount = 0
  while controls[1,3] = 0 or framecount <= GetFrameRate()
	framecount = framecount + 1
		
	   instructions = {{-120,90,"HIT POINTS.." + playerDetails[5]},_
				{-120,70,"STRENGTH...." + playerDetails[8]},_	
				{-120,50,"DEXTERITY..." + playerDetails[9]},_
				{-120,30,"STAMINA....." + playerDetails[10]},_
				{-120,10,"WISDOM......" + playerDetails[11]},_
				{-120,-10,"GOLD......." + playerDetails[6]}}
		
	    call ClearScreen()
		call TextSizeSprite(textSize)
	    call TextListSprite(instructions)

       if startup = 1 then
          instructions2 = {{-120,-50,"SHALT THOU PLAY WITH THESE QUALITIES?"},_
		                   {-120,-70,"1=ACCEPT, 2=REROLL"}}
	      call TextListSprite(instructions2)
       endif	   
      controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY)
      if controls[1,4] = 1 and startup = 1 then
        call rollStats()	  
      endif
  endwhile
  framecount = 0
endsub

sub LB()
  framecount = 0  
  print "pb17=" + playerDetails[17] 
  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
  if playerDetails[17] = 0 then
    call ClearScreen()
    call TextSizeSprite(textSize)
    instructions = {{-120,90,"WELCOME PEASANT INTO THE HALLS OF"},_
                      {-120,70,"THE MIGHTY LORD BRITISH. HEREIN"},_
                      {-120,50,"THOU MAY CHOOSE TO DARE BATTLE"},_
                      {-120,30,"WITH THE EVIL CREATURES OF THE"},_
                      {-120,10,"DEPTHS FOR GREAT REWARD!"}}
    call TextListSprite(instructions)	 
    while controls[1,3] = 0 or framecount < GetFrameRate()/4
      framecount = framecount + 1	
      controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 	  
	endwhile
	framecount = 0   
	call ClearScreen()
	call TextSizeSprite(textSize)
	instructions = {{-120,90,"DOEST THOU WISH FOR GRAND"},_
                      {-120,70,"ADVENTURE?"}}
      call TextListSprite(instructions)	 
    while controls[1,3] = 0 or framecount < GetFrameRate()/4
      framecount = framecount + 1	
      controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 	  
	endwhile
	framecount = 0
	call ClearScreen()
	playerDetails[17] = 10	
	instructions = {{-120,90,"GOOD! THOU SHALT TRY TO BECOME"},_
                      {-120,70,"A KNIGHT!!! THY FIRST TASK"},_
                      {-120,50,"IS TO GO INTO THE DUNGEONS"},_
                      {-120,30,"AND ONLY RETURN AFTER KILLING"},_
                      {-120,10,"A " + monsters[playerDetails[17]]}}
    call TextListSprite(instructions)	 
	call TextSizeSprite(textSize)
    while controls[1,3] = 0 or framecount < GetFrameRate()/4
      framecount = framecount + 1	
      controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 	  
	endwhile
	framecount = 0
	playerDetails[8] = playerDetails[8] + 1
	playerDetails[9] = playerDetails[9] + 1
	playerDetails[10] = playerDetails[10] + 1
	playerDetails[11] = playerDetails[11] + 1
	
	call ClearScreen()
	instructions = {{-120,90,"GO NOW UPON THIS QUEST, AND"},_
                      {-120,70,"MAY LADY LUCK BE FAIR UNTO YOU"},_
                      {-120,50,"ALSO I, BRITISH, HAVE INCREASED"},_
                      {-120,30,"EACH OF THY ATTRIBUTES BY 1"}}
    call TextListSprite(instructions)	 
	call TextSizeSprite(textSize)
    while controls[1,3] = 0 or framecount < GetFrameRate()/4
      framecount = framecount + 1	
      controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 	  
	endwhile
	framecount = 0
  else
	  if playerDetails [18] = 1 then
		playerDetails[18] = 0
		playerDetails[17] =  playerDetails[17] - 1
		call ClearScreen()
		instructions = {{-120,90,"AAHH!!....."},_
						{-120,70,"THOU HAST ACOMPLISHED THY QUEST!"}}
		  playerDetails[8] = playerDetails[8] + 1
		  playerDetails[9] = playerDetails[9] + 1
		  playerDetails[10] = playerDetails[10] + 1
		  playerDetails[11] = playerDetails[11] + 1 
		  call TextSizeSprite(textSize)
		  call TextListSprite(instructions)	
		while controls[1,3] = 0 or framecount < GetFrameRate()/4
		  framecount = framecount + 1	  
		  controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 
		endwhile
		framecount = 0
		call ClearScreen()
		if playerDetails[17] > 0 then
			instructions = {{-120,90,"UNFORTUNATELY, THIS IS NOT"},_
							{-120,70,"ENOUGH TO BECOME A KNIGHT"},_
							{-120,50,"NOW THOU MUST KILL A"},_
							{-120,30,monsters[playerDetails[17]]}} 
		      call TextSizeSprite(textSize)
			  call TextListSprite(instructions)	 
			while controls[1,3] = 0 or framecount < GetFrameRate()/4
			  framecount = framecount + 1	  
			  controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 
			endwhile
			framecount = 0
	    else
		  instructions = {{-120,90,"THOU HAS PROVED THYSELF WORTHY"},_
							{-120,70,"OF KNIGHTHOOD, CONTINUE PLAY"},_
							{-120,50,"IF THOU DOTH WISH, BUT THOU HAST"},_
							{-120,30,"ACCOMPLISHED THE MAIN OBJECTIVE"},_
							{-120,10,"OF THIS GAME..."}} 
		      call TextSizeSprite(textSize)
			  call TextListSprite(instructions)	 
			while controls[1,3] = 0 or framecount < GetFrameRate()/4
			  framecount = framecount + 1	  
			  controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 
			endwhile
			framecount = 0
			call ClearScreen()
			if gameLevel < 10 then
				instructions = {{-120,90,"NOW MAYBE THOU ART FOOLHARDY"},_
								{-120,70,"ENOUGH TO TRY DIFFICULTY"},_
								{-120,50,"LEVEL " + (gameLevel + 1)}}
		    else
			  instructions = {{-120,90,"REPORT THIS AMAZING FEAT TO"},_
								{-120,70,"LORD BRITISH (@RICHARDGARRIOTT)"}}
			endif 
		      call TextSizeSprite(textSize)
			  call TextListSprite(instructions)	 
			while controls[1,3] = 0 or framecount < GetFrameRate()/4
			  framecount = framecount + 1	  
			  controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 
			endwhile
			framecount = 0
	    endif			
	  else
		call ClearScreen() 
		  call TextSizeSprite(textSize)
		  instructions = {{-120,90,"WHY HAST THOU RETURNED?"},_
		                  {-120,70,"THOU MUST KILL A"},_
						  {-120,50,monsters[playerDetails[17]]}}
			call TextListSprite(instructions)
		  while controls[1,3] = 0 or framecount < GetFrameRate()/4
			framecount = framecount + 1	  
		  controls = WaitForFrame(JoystickDigital,Controller1,JoystickNone) 
		  endwhile
	   endif
	endif
endsub

sub Trap()
  call clearScreen() 
  call TextSizeSprite(textSize)
  instructions = {{-80,50,"AAARRRGGGHHH!!! A TRAP"}}	
      call TextListSprite(instructions)	   
	framecount = 0
    while framecount < GetFrameRate()/2 or controls[1,3] = 0 
      framecount = framecount + 1	  
	  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
	endwhile
	playerDetails[5] = playerDetails[5] - round(((Rand() MOD 1000)/1000) * playerDetails[7] + 3)
	playerDetails[7] = playerDetails[7] + 1	
	call generateLevels()
	call AddMonsters
	call showPositionD()
endsub

sub Move(direction)
  if ((playerDetails[3] = 3 and direction = "F") or (playerDetails[3] = 1 and direction = "B")) and MoveAllowed(3) then
    if level[playerDetails[1] + ((playerDetails[2] * 9)-9) + 9,5] >10 or level[playerDetails[1] + ((playerDetails[2] * 9)-9) + 9,5] = 0 then
      playerDetails[2] = playerDetails[2] + 1
	endif
  elseif ((playerDetails[3] = 1 and direction = "F") or (playerDetails[3] = 3 and direction = "B")) and MoveAllowed(1)  then
    if level[playerDetails[1] + ((playerDetails[2] * 9)-9) - 9,5] >10 or level[playerDetails[1] + ((playerDetails[2] * 9)-9) - 9,5] = 0 then
      playerDetails[2] = playerDetails[2] - 1
	endif
  elseif ((playerDetails[3] = 2 and direction = "F") or (playerDetails[3] = 4 and direction = "B")) and MoveAllowed(2)  then
    if level[playerDetails[1] + ((playerDetails[2] * 9)-9) + 1,5] >10 or level[playerDetails[1] + ((playerDetails[2] * 9)-9) + 1,5] = 0 then
      playerDetails[1] = playerDetails[1] + 1	
	endif
  elseif ((playerDetails[3] = 4 and direction = "F") or (playerDetails[3] = 2 and direction = "B")) and MoveAllowed(4)  then
    if level[playerDetails[1] + ((playerDetails[2] * 9)-9) - 1,5] >10 or level[playerDetails[1] + ((playerDetails[2] * 9)-9) - 1,5] = 0 then
      playerDetails[1] = playerDetails[1] - 1
	endif
  endif  
  
  if playerDetails[7] > 0 then 'inside
    playerDetails[4] = playerDetails[4] - 1
	if level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] = 15 then
	  call Trap()
	endif
    call MoveMonsters
  else
    playerDetails[4] = playerDetails[4] - 10
  endif
  
  framecount = 0
  
  if playerDetails[4] <=0 then
    playerDetails[4] = 0
    playerDetails[5] = playerDetails[5] - 10
  endif
  print "x=" + playerDetails[1] + ":y=" + playerDetails[2]
endsub

function MoveAllowed(direction)
  if  level[playerDetails[1] + ((playerDetails[2] * 9)-9),direction] <> 1 then
    return true
  else    
    return false
  endif
endfunction

sub AddMonsters 
  for x = 1 to 10
    monsterHP[x] = (2 * (11-x)) + (2 * playerDetails[7] + gameLevel)
	'removing the randomness for monsters so you get them all every level and RAND() MOD 10 < 4
	if (11-x) -2 < playerDetails[7] then
	  exitloop = 0
	    while exitloop = 0
		  r = (RAND() MOD 80) + 1
		  if level[r,5] = 0 and (level[r,1] <> 1 or level[r,2] <> 1 or level[r,3] <> 1 or level[r,4] <> 1) then
		    exitloop = 1
			level[r,5] = x
		  endif
		endwhile
    endif
  next x
endsub

sub MoveMonsters
  'since we basically have vertical corridors prioritize up and down

  for z=1 to 81
    if level[z,5] > 0 and level [z,5] < 11  then 'monster ahoy	
	    
      adjToPlayer = false
	  monsterx = z MOD 9
	  monstery = 1+((z - monsterx)/9)
	  
	  if (monsterx = playerDetails[1] and monstery - playerDetails[2] <=1 and monstery - playerDetails[2] >= -1) _
	      or (monstery = playerDetails[2] and monsterx - playerDetails[1] <=1 and monsterx - playerDetails[1] >= -1) then
		 adjToPlayer = true
	  endif
	  
	  if playerDetails[2]>monstery and level[z,3] <> 1 and (level[z+9,5] = 0 or adjToPlayer) then
	    call MoveMonster(level[z,5], z+9)
	  elseif playerDetails[2]<monstery and level[z,1] <> 1 and (level[z-9,5] = 0 or adjToPlayer) then
	    call MoveMonster(level[z,5], z-9)
	  elseif playerDetails[1]<monsterx and level[z,4] <> 1 and (level[z-1,5] = 0 or adjToPlayer) then
	    call MoveMonster(level[z,5], z-1)
	  elseif playerDetails[1]>monsterx and level[z,2] <> 1 and (level[z+1,5] = 0 or adjToPlayer) then
	    call MoveMonster(level[z,5], z+1)	    
      endif	  
	endif
  next z
endsub

sub MoveMonster(monster, location)
  if playerDetails[1] + ((playerDetails[2]-1)*9) = location then
    call AttackPlayer(monster)
  else
    for z=1 to 81
	  if level[z,5] = monster then
	    level[z,5] = 0	    
	  endif
	next z
	level[location,5] = monster
  endif
endsub

sub AttackPlayer (monster)
  message1 = "YOU ARE BEING ATTACKED BY A " + monsters[monster]
  message2 = " "
  if (monster = 3 or monster = 9) and RAND() MOD 2 = 1 then
    'thieving type monster doing some thievery
	if monster = 3 then
	  message2 = "GREMLIN STOLE SOME FOOD!!!"
      playerDetails[4] = round(playerDetails[4]/2)
    else
	  r = RAND() MOD 5 + 12
	  if playerDetails[r] > 0 and (playerDetails[r] > 1 or playerDetails[19] <> r) then
	    playerDetails[r] = playerDetails[r] - 1		
	    message2 = "A THIEF STOLE AN ITEM!!!"
      endif
	endif
  else
    if RAND() MOD 21 - (((playerDetails[14]+1)/(playerDetails[14]+1)) -1) - playerDetails[10] + (11-monster) + playerDetails[7] < 0 then
	  message2 = "MISSED"
	else
	  hploss = round((RAND() MOD 1000 * (11-monster))/1000) + playerDetails[7]
	  message2 = "HIT FOR " + hploss + " HP"
	  playerDetails[5] = playerDetails[5] - hploss
	endif
  endif
  call clearScreen() 
  call TextSizeSprite(textSize)
  instructions = {{-120,50,message1},_
				{-120,30,message2}}			
      call TextListSprite(instructions)	   
	framecount = 0
    while framecount < GetFrameRate()/2 or controls[1,3] = 0
      framecount = framecount + 1	  
	  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
	endwhile
endsub

sub MagesCant ()
  call clearScreen() 
  call TextSizeSprite(textSize)
  instructions = {{-80,50,"I'M SORRY. MAGES CAN'T USE THAT"}}			
      call TextListSprite(instructions)	   
	framecount = 0
    while framecount < GetFrameRate()/2 or controls[1,3] = 0
      framecount = framecount + 1	  
	  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
	endwhile
	framecount = 0
endsub

function stringToInt(s)
  r = 0
  f = 0.0
  prefloat = 0
  floating = 0
  m = 1
  for i = 1 to Len(s)
    z = Mid(s,i,1)
	if z = "1" then
	  r = (r*10) + 1
	elseif z = "2" then
	  r = (r*10) + 2
	elseif z = "3" then
	  r = (r*10) + 3
	elseif z = "4" then
	  r = (r*10) + 4
	elseif z = "5" then
	  r = (r*10) + 5
	elseif z = "6" then
	  r = (r*10) + 6
	elseif z = "7" then
	  r = (r*10) + 7
	elseif z = "8" then
	  r = (r*10) + 8
	elseif z = "9" then
	  r = (r*10) + 9
	elseif z = "0" then
	  r = (r*10) 
	elseif z = "-" then
	  m = -1 
	elseif z = "." then
	  prefloat = Float(r)
	  floating = 1
	  r = 0
	endif	
  next i
  if floating then 
    r = prefloat + (Float(r)/10)
  endif
  return r * m
endfunction

function myRand()
  seed = (1103515245 * seed + 12345) MOD 2147483648‬
  if seed < 1 then
    seed = seed * -1
  endif
  print "seed=" + seed
  return seed
endfunction

function amuletSelect()
  call clearScreen() 
  call TextSizeSprite(textSize)
  instructions = {{-80,50,"1 - LADDER UP"},_
                  {-80,30,"2 - LADDER DOWN"},_
				  {-80,10,"3 - KILL"},_
				  {-80,-10,"4 - BAD??"}}	
      call TextListSprite(instructions)	   
	framecount = 0
    while framecount < GetFrameRate()/2 or (controls[1,3] = 0 and controls[1,4] = 0 and controls[1,5] = 0 and controls[1,6] = 0)
      framecount = framecount + 1	  
	  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
	endwhile
	if controls[1,3] = 1 then
	  return 1
	elseif controls[1,4] = 1 then
	  return 2
	elseif controls[1,5] = 1 then
	  return 3
	else
	  return 4
    endif
endfunction

sub strike()
  call clearScreen()
  message1 = " "
  message2 = " "
  message3 = " "
  message4 = " "
  message5 = " "
  dam = 0
  amnotattack = 0
  
  if playerDetails[19] = 12 then
    dam = 10
  elseif playerDetails[19] = 13 then
    dam = 5
  elseif playerDetails[19] = 14 then
    dam = 1
  elseif playerDetails[19] = 15 then
    dam = 4
  elseif playerDetails[19] = 16 then
    'magic amulet	
	amnotattack = 1
	ran = RAND() MOD 4
	if playerDetails[20] = 2 then
	  ran = AmuletSelect() - 1
	  call clearScreen()	  
	endif
	if ran = 0 then
	  'dont overwrite a monster with a ladder
	  if level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] < 1 or level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] > 10 then
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] = 11
	    message1 = "POOF! A LADDER"
	  else
	    message1 = "FIZZLE"
	  endif
	elseif ran = 1 then
	  if level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] < 1 or level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] > 10 then
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] = 13
	    message1 = "POOF! A LADDER"
	  else
	    message1 = "FIZZLE"
	  endif
	elseif ran = 2 then
	  dam = 10 + playerDetails[7]	  
	  amnotattack = 0
	else
	  ran2 = RAND() MOD 3
	  if ran2 = 0 then
	    message1 = "YOU HAVE BEEN TURNED INTO A TOAD!"
		playerDetails[8] = 3
		playerDetails[9] = 3
		playerDetails[10] = 3
		playerDetails[11] = 3
	  elseif ran2 = 1 then
	    message1 = "YOU HAVE BEEN TURNED INTO A LIZARDMAN!"
		playerDetails[8] = round(playerDetails[8]*2.5)
		playerDetails[9] = round(playerDetails[9]*2.5)
		playerDetails[10] = round(playerDetails[10]*2.5)
		playerDetails[11] = round(playerDetails[11]*2.5)
	  elseif ran2 = 2 then
	    message1 = "BACKFIRE!!!!"
		playerDetails[5] = round(playerDetails[5]/2)
	  endif		  
    endif	
    ran = RAND() MOD 4
    if ran = 1 then
      message5 = "LAST CHARGE ON THIS AMULET!"	
	  playerDetails[16] = playerDetails[16] - 1
	  if playerDetails[16] = 0 then
	    playerDetails[19] = 0
	  endif
	endif 
  endif
  
  
  
  print "mon="+mon 
  'is this a short range attack?
  beforemon = mon
  beforemonloc = monlocation
  
  if amnotattack = 0 and playerDetails[19]<15 then 
	  if playerDetails[3] = 3 and MoveAllowed(3) then
		monlocation = playerDetails[1] + (((playerDetails[2]+1) * 9)-9)
		mon = level[monlocation,5]
	  elseif playerDetails[3] = 1 and MoveAllowed(1)  then
		monlocation = playerDetails[1] + (((playerDetails[2]-1) * 9)-9)
		mon = level[monlocation,5]
	  elseif playerDetails[3] = 2 and MoveAllowed(2)  then
		monlocation = (playerDetails[1] +1)+ ((playerDetails[2] * 9)-9)
		mon = level[monlocation,5]
	  elseif playerDetails[3] = 4 and MoveAllowed(4)  then
		monlocation = (playerDetails[1] -1)+ ((playerDetails[2] * 9)-9)
		mon = level[monlocation,5]
	  endif  
  endif
  
  if mon = 0 and playerDetails[19] = 13 and beforemon <> 0 then
    'throwing an axe
	playerDetails[13] = playerDetails[13] - 1
	if playerDetails[13] = 0 then 
	  playerDetails[19] = 0
	endif
	mon = beforemon
	monlocation = beforemonloc
  endif
   
  print "mon="+mon   
  if amnotattack = 0 then
	if mon = 0 or mon > 10 then
		 message1 = "YOU MISSED"
	  else
		 if (playerDetails[9] * 1000) - ((Rand() MOD 1000) * 25) < (11-mon) * 1000 then
		   print "missed by chance"
		   message1 = "YOU MISSED"
		 else
			dam = round((((Rand() MOD 1000) * dam)/1000) + playerDetails[8]/5)
			monsterHP[mon] = monsterHP[mon] - dam
			message1 = "HIT! DAMAGE = " + dam
		 endif
		 
		 if monsterHP[mon] < 0 then
		   message2 = "YOU KILLED A " + monsters[mon]
		   gold = (11-mon) + playerDetails[7]
		   message3 = "THOU SHALT RECEIVE " + gold + " GOLD"		   
		   playerDetails[6] = playerDetails[6] + gold
		   level[monlocation,5] = 0
		   'doesnt seem generous enough so removing the 2 divider
		   hpincrementer = hpincrementer + round(playerDetails[7] * (11-mon)/2)
		   print "hpincrementer=" + hpincrementer
		   if playerDetails[17] = mon and playerDetails[18] = 0 then
			 playerDetails[18] = 1
			 message4 = "A QUEST HAS BEEN COMPLETED"
		   endif
		 endif
	endif	 
  endif
	  instructions = {{-120,50,message1},_
				{-120,30,message2},_	
				{-120,10,message3},_	
				{-120,-10,message4},_	
				{-120,-10,message5}}		 
	  call TextSizeSprite(textSize)	
      call TextListSprite(instructions)	   
	framecount = 0
    while framecount < GetFrameRate()/2 or controls[1,3] = 0
      framecount = framecount + 1	  
	  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
	endwhile
endsub

sub deaded()
  call clearScreen() 
  call TextSizeSprite(textSize)
  instructions = {{-80,50,"WE MOURN THE PASSING OF THE PEASANT"},_
                  {-80,30,"AND HIS COMPUTER."},_
				  {-80,10,"PRESS 1 TO INVOKE A MIRACLE"},_
				  {-80,-10,"OF RESURRECTION"}}	
      call TextListSprite(instructions)	   
	framecount = 0
    while framecount < GetFrameRate()/2 or controls[1,3] = 0 
      framecount = framecount + 1	  
	  controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
	endwhile
	call stats(1)
	for i = 13 to 19 
	  playerDetails[i] = 0
	next i	
    if playerDetails[7] <> 0 then	
		playerDetails[1]=outsideX;
		playerDetails[2]=outsideY;
		playerDetails[7] = 0
	endif
	playerDetails[4]=600
	hpincrementer = 0;
	framecount = 0
	call showPositionO()
endsub

sub chest()
  gp = round(((RAND() MOD 1000) * 5 * playerDetails[7])/1000) + playerDetails[7]
  items = {"RAPIER","AXE","SHIELD","BOW","AMULET"}
  playerDetails[6] = playerDetails[6] + gp
  item = (RAND() MOD 5) + 1
  playerDetails [item + 11] = playerDetails [item + 11] + 1

  call clearScreen() 
  call TextSizeSprite(textSize)
  level[playerDetails[1] + ((playerDetails[2] * 9)-9),5] = 0
  instructions = {{-80,50,"GOLD!!!!! " + gp + "-PIECES OF EIGHT"},_
                  {-80,30,"AND A " + items[item]}}	
  call TextListSprite(instructions)	   
  framecount = 0
  while framecount < GetFrameRate()/2 or controls[1,3] = 0 
    framecount = framecount + 1	  
	controls = WaitForFrame(JoystickDigital,Controller1,JoystickX + JoystickY) 
  endwhile	
  framecount = 0
  call ShowPositionD()
endsub

sub generateLevels()
     seed = luckynumber + (playerDetails[7] * 15243)
	 '0 everything
	 for i = 1 to 81
	   for j = 1 to 5
		 level[i,j] = 0
	   next j
	 next i
	   
	 'put in the base walls
	 for i = 1 to 81
	   level [i,1] = 1 
	   level [i,2] = 1
	   level [i,3] = 1
	   level [i,4] = 1
		   'level [(((i+1)*9)-1)+(2*j),k] = 1
		 'next k
	   'next j
      next i
	
	for i = 1 to 5
	  for j = 1 to 4
	    xy = ((9*i*2)-18)+((2*j))
	    yx = ((9*j*2)-10)+(2*i)
		'upped chance from 94 as too many
	    if myRand() MOD 100 > 97 then 
	      level [xy,2] = 0
	      level [xy,4] = 0
	      level [xy,5] = 15
	      level [xy + 1,4] = 0
	      level [xy - 1,2] = 0		  
	    endif
	    if myRand() MOD 100 > 97 then 
	      level [yx,1] = 0
	      level [yx,3] = 0
	      level [yx,5] = 15
	      level [yx + 9,1] = 0
	      level [yx - 9,3] = 0			  
	    endif
	    if myRand() MOD 100 > 59 then 
	      level [xy,2] = 0
	      level [xy,4] = 0
	      level [xy,5] = 0
	      level [xy + 1,4] = 2
	      level [xy - 1,2] = 2		  
	    endif
	    if myRand() MOD 100 > 59 then 
	      level [yx,1] = 0
	      level [yx,3] = 0
	      level [yx,5] = 0
	      level [yx + 9,1] = 2
	      level [yx - 9,3] = 2			  
	    endif
	    if myRand() MOD 100 > 59 then 
	      level [xy,2] = 0
	      level [xy,4] = 0
	      level [xy,5] = 0
	      level [xy + 1,4] = 3
	      level [xy - 1,2] = 3		  
	    endif
	    if myRand() MOD 100 > 59 then 
	      level [yx,1] = 0
	      level [yx,3] = 0
	      level [yx,5] = 0
	      level [yx + 9,1] = 3
	      level [yx - 9,3] = 3			  
	    endif
		'not enough breaks in the wall so I am adding some
	    if myRand() MOD 100 > 59 then 
	      level [xy,2] = 0
	      level [xy,4] = 0
	      level [xy,5] = 0
	      level [xy + 1,4] = 0
	      level [xy - 1,2] = 0		  
	    endif
	    if myRand() MOD 100 > 59 then 
	      level [xy,2] = 0
	      level [xy,4] = 0
	      level [xy,5] = 0
	      level [xy + 1,4] = 0
	      level [xy - 1,2] = 0		  
	    endif
	    if myRand() MOD 100 > 59 then 
	      level [yx,1] = 0
	      level [yx,3] = 0
	      level [yx,5] = 0
	      level [yx + 9,1] = 0
	      level [yx - 9,3] = 0			  
	    endif
	    if myRand() MOD 100 > 59 then 
	      level [yx,1] = 0
	      level [yx,3] = 0
	      level [yx,5] = 0
	      level [yx + 9,1] = 0
	      level [yx - 9,3] = 0			  
	    endif
	    if myRand() MOD 100 > 96 then 
	      level [xy,2] = 0
	      level [xy,4] = 0
	      level [xy,5] = 14
	      level [xy + 1,4] = 0
	      level [xy - 1,2] = 0		  
	    endif
	    if myRand() MOD 100 > 96 then 
	      level [yx,1] = 0
	      level [yx,3] = 0
	      level [yx,5] = 14
	      level [yx + 9,1] = 0
	      level [yx - 9,3] = 0			  
	    endif
	    if myRand() MOD 100 > 93 then 
	      level [xy,2] = 0
	      level [xy,4] = 0
	      level [xy,5] = 12
	      level [xy + 1,4] = 0
	      level [xy - 1,2] = 0		  
	    endif
	    if myRand() MOD 100 > 93 then 
	      level [yx,1] = 0
	      level [yx,3] = 0
	      level [yx,5] = 12
	      level [yx + 9,1] = 0
	      level [yx - 9,3] = 0			  
	    endif
	  next j
	next i
	
	
	'make sure outside walls are still there...
	 for i = 1 to 9	 
	   level [i,1] = 1 
	   level [(9*i)-8,4] = 1
	   level [82-i,3] = 1
	   level [9*i,2] = 1
	 next i
	
	level [2,2] = 0
	level [2,4] = 0
	level [2,5] = 0
	level [3,4] = 0
	level [1,2] = 0			  
	
	if playerDetails[7] MOD 2 = 0 then
	  level[25,5] = 13
	  level[57,5] = 11
	  mazestart = 57;
	  mazeend=25;
	elseif playerDetails[7] = 1 then	  
	  level[1,5] = 11
	  level[57,5] = 13
	  mazestart = 57;
	  mazeend=1;
	else 	  
	  level[25,5] = 11
	  level[57,5] = 13
	  mazestart = 57;
	  mazeend=25;
	endif
	
	'remove walls if player trapped
	if level[playerDetails[1] + ((playerDetails[2] * 9)-9),1] = 1 and level[playerDetails[1] + ((playerDetails[2] * 9)-9),2] = 1 and level[playerDetails[1] + ((playerDetails[2] * 9)-9),3] = 1 _
    	and level[playerDetails[1] + ((playerDetails[2] * 9)-9),4] = 1 then
	  if playerDetails[1] MOD 2 = 0 then
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9),2] = 0
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9),4] = 0
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9) -1,2] = 0
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9) + 1,4] = 0
	  else
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9),1] = 0
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9),3] = 0
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9) -9,3] = 0
	    level[playerDetails[1] + ((playerDetails[2] * 9)-9) + 9,1] = 0
	  endif
	endif
	
	'attempt to solve maze
	for i =1 to 81
	  correctPath[i] = false
	  wasHere[i] = false
	next i
	print "maxestart=" + mazestart
	print "mazeend=" + mazeend
	if solveMaze(mazestart)
	  print "solvable"
	else
	  print "not solvable"
      call clearMaze(mazeend)	  
	endif		
	
endsub

sub clearMaze(coords)
  
   
	  coordsX = coords MOD 9
	  coordsY = 1+((coords - coordsX)/9)
	  endX = mazestart MOD 9
	  endY = 1+((mazestart - endX)/9)
	  
  direction = 0
  
	if endY>coordsY then
	  direction = 3 
	elseif endY<coordsY then
	  direction = 1
	elseif endX<coordsX then
	  direction = 4 
	elseif endX>coordsX then
	  direction = 2 	    
    endif	
	  
  level[coords,direction] = 0;
  if direction = 1 then
   level[coords-9,3] = 0
   if not wasHere[coords-9] then
     call clearMaze(coords-9)
   endif
  endif
  if direction = 2 then
   level[coords+1,4] = 0
   if not wasHere[coords+1] then
     call clearMaze(coords+1)
   endif
  endif
  if direction = 3 then
   level[coords+9,1] = 0
   if not wasHere[coords+9] then
     call clearMaze(coords+9)
   endif
  endif
  if direction = 4 then
   level[coords-1,2] = 0
   if not wasHere[coords-1] then
     call clearMaze(coords-1)
   endif
  endif
  
endsub

function solveMaze(coords) 
  print "coords=" + coords
  wasHere[coords] = true
  
  for i = 1 to 200   
	  for j = 1 to 81	  
	    if j = mazeend and wasHere[j] then
		  return true
	    endif
		if not wasHere[j] then	  
		  if level[j,4] <> 1 and wasHere[j-1] then
			wasHere[j] = true
		  endif 
		  if level[j,1] <> 1 and wasHere[j-9] then
			wasHere[j] = true
		  endif 
		  if  level[j,2] <> 1 and wasHere[j+1] then
			wasHere[j] = true
		  endif 
		  if  level[j,3] <> 1 and wasHere[j+9] then
			wasHere[j] = true
		  endif
		 endif
      next j
   next i
  return false
  
endfunction

